Get multiple documents
- POST also GET /{index}/_mget
- POST also GET /_mget
Get multiple JSON documents by ID from one or more indices. If you specify an index in the request URI, you only need to specify the document IDs in the request body. To ensure fast responses, this multi get (mget) API responds with partial results if one or more shards fail.
Filter source fields
By default, the _source field is returned for every document (if stored).
Use the _source and _source_include or source_exclude attributes to filter what fields are returned for a particular document.
You can include the _source, _source_includes, and _source_excludes query parameters in the request URI to specify the defaults to use when there are no per-document instructions.
Get stored fields
Use the stored_fields attribute to specify the set of stored fields you want to retrieve.
Any requested fields that are not stored are ignored.
You can include the stored_fields query parameter in the request URI to specify the defaults to use when there are no per-document instructions.
- Index privileges:
read
Path Parameters
-
indexstring IndexNameoptional -
Name of the index to retrieve documents from when
idsare specified, or when a document in thedocsarray does not specify an index.Leave it out to use
/_mget.
Query Parameters
-
preferencestring Specifies the node or shard the operation should be performed on. Random by default.
-
realtimeboolean · default: true If
true, the request is real-time as opposed to near-real-time.-
refreshboolean · default: false If
true, the request refreshes relevant shards before retrieving documents.-
routingRouting Custom value used to route operations to a specific shard. Not allowed when
index.slice.enabledistruefor the target index; use_sliceinstead.-
_sourceSourceConfigParam True or false to return the
_sourcefield or not, or a list of fields to return.-
_source_excludesFields A comma-separated list of source fields to exclude from the response. You can also use this parameter to exclude fields from the subset specified in
_source_includesquery parameter.-
_source_includesFields A comma-separated list of source fields to include in the response. If this parameter is specified, only these source fields are returned. You can exclude fields from this subset using the
_source_excludesquery parameter. If the_sourceparameter isfalse, this parameter is ignored.-
stored_fieldsstring Fields · default: false If
true, retrieves the document fields stored in the index rather than the document_source.
Request
-
docsOperation -
The documents you want to retrieve. Required if no index is specified in the request URI.
-
_idstring Idrequired -
The unique document ID.
-
_indexstring IndexName -
The index that contains the document.
-
routingstring Routing -
The key for the primary shard the document resides on. Required if routing is used during indexing.
-
_sourceSourceConfig -
If
false, excludes all _source fields. -
stored_fieldsstring Fields -
The stored fields you want to retrieve.
-
versionnumber VersionNumber -
version_typeVersionType -
Supported values include:
internal: Use internal versioning that starts at 1 and increments with each update or delete.external: Only index the document if the specified version is strictly higher than the version of the stored document or if there is no existing document.external_gte: Only index the document if the specified version is equal or higher than the version of the stored document or if there is no existing document. NOTE: Theexternal_gteversion type is meant for special use cases and should be used with care. If used incorrectly, it can result in loss of data.
-
Values:
internalexternalexternal_gte -
idsstring Ids -
The IDs of the documents you want to retrieve. Allowed when the index is specified in the request URI.
Response
-
docsResponseItemrequired -
The response includes a docs array that contains the documents in the order specified in the request. The structure of the returned documents is similar to that returned by the get API. If there is a failure getting a particular document, the error is included in place of the document.
-
_indexstring IndexNamerequired -
The name of the index the document belongs to.
-
fieldsmap string to object -
If the
stored_fieldsparameter is set totrueandfoundistrue, it contains the document fields stored in the index. -
_ignoredstring -
foundbooleanrequired -
Indicates whether the document exists.
-
_idstring Idrequired -
The unique identifier for the document.
-
_primary_termnumber -
The primary term assigned to the document for the indexing operation.
-
_routingstring -
The explicit routing, if set.
-
_seq_nonumber SequenceNumber -
The sequence number assigned to the document for the indexing operation. Sequence numbers are used to ensure an older version of a document doesn't overwrite a newer version.
-
_sourceobject -
If
foundistrue, it contains the document data formatted in JSON. If the_sourceparameter is set tofalseor thestored_fieldsparameter is set totrue, it is excluded. -
_versionnumber VersionNumber -
The document version, which is ncremented each time the document is updated.
-
errorErrorCauserequired -
typestringrequired -
The type of error
-
reasonstringnullable -
A human-readable explanation of the error, in English.
-
stack_tracestring -
The server stack trace. Present only if the
error_trace=trueparameter was sent with the request. -
caused_byErrorCause -
root_causeErrorCause -
suppressedErrorCause -
_idstring Idrequired -
_indexstring IndexNamerequired